#version 120

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;

varying vec2 v_texcoord;
varying vec4 v_color;
varying vec2 v_mask;

void main() {
	float y = texture2D(texture0, v_texcoord).r;
	float u = texture2D(texture1, v_texcoord).r - 0.5;
	float v = texture2D(texture2, v_texcoord).r - 0.5;

	float r = y + 1.474 * v;
	float g = y - 0.1645 * u - 0.5713 * v;
	float b = y + 1.8814 * u;

	vec4 finalColor = vec4(r * v_color.r, g * v_color.g, b * v_color.b, v_color.a) * v_mask.x;
	finalColor.r *= finalColor.a;
	finalColor.g *= finalColor.a;
	finalColor.b *= finalColor.a;
	gl_FragColor = finalColor;
}
